import {defaultEnvironment} from "@environments/environment.defaults";
import {environmentLocal} from "@environments/environment.local";
import {ThemeEnum} from "@shared/enums/theme.enum";
import {DlcmEnvironment} from "./environment.defaults.model";

// This config is for developer using test.dlcm.ch as backend (rather than local backend)
export const environment: DlcmEnvironment = {
  ...defaultEnvironment,
  theme: ThemeEnum.dlcm,
  scope: "READ",
  requireHttps: false,
  showDebugInformation: false,
  isDemoMode: false,
  dummyClientSecret: "123abc",
  clientId: "dlcm-test-local-angular",
  redirectUrl: "http://localhost:4200/",
  admin: "https://e-research-test.unige.ch/dlcm-test/administration/admin",
  forceRuntimeOverrideSetting: true,
  computeOAuthEndpoint: true,
  ...environmentLocal,
};
