import {ThemeEnum} from "@app/shared/enums/theme.enum";
import {defaultEnvironment} from "./environment.defaults";
import {DlcmEnvironment} from "./environment.defaults.model";
import {environmentLocal} from "./environment.local";

export const environment: DlcmEnvironment = {
  ...defaultEnvironment,
  theme: ThemeEnum.dlcm,
  useSelfHostedStreamSaverMitm: false,

  // Override OAuth2 properties
  dummyClientSecret: "123abc",
  clientId: "local-dev-angular",
  responseType: "token",
  scope: "READ",
  requireHttps: false,
  redirectUrl: window.location.origin,

  admin: "http://localhost:16105/dlcm/admin",

  //Override properties inside environment.local.ts
  ...environmentLocal,
};
