import {defaultEnvironment} from "@environments/environment.defaults";
import {ThemeEnum} from "@shared/enums/theme.enum";
import {DlcmEnvironment} from "./environment.defaults.model";

export const environment: DlcmEnvironment = {
  ...defaultEnvironment,
  // Override OAuth2 properties
  appTitle: "DLCM - Portal",
  production: true,
  theme: ThemeEnum.yareta,
  useSelfHostedStreamSaverMitm: true,
  computeOAuthEndpoint: true,

  admin: "https://test.dlcm.ch/administration/",

  // OAuth2 properties
  dummyClientSecret: "123abc",
  clientId: "dlcm-test-angular",
  responseType: "token",
  scope: "READ",
  requireHttps: false,
  redirectUrl: "https://test.dlcm.ch/portal/",
};
